    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------
    028     * Arrangement.java
    029     * ----------------
    030     * (C) Copyright 2004-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 22-Oct-2004 : Version 1 (DG);
    038     * 11-Feb-2005 : Modified arrange() method to return Size2D (DG);
    039     * 22-Apr-2005 : Reordered arguments in arrange() method (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.block;
    044
    045    import java.awt.Graphics2D;
    046
    047    import org.jfree.ui.Size2D;
    048
    049    /**
    050     * An object that is responsible for arranging a collection of {@link Block}s
    051     * within a {@link BlockContainer}.
    052     */
    053    public interface Arrangement {
    054
    055        /**
    056         * Adds a block and a key which can be used to determine the position of
    057         * the block in the arrangement.  This method is called by the container
    058         * (you don't need to call this method directly) and gives the arrangement
    059         * an opportunity to record the details if they are required.
    060         *
    061         * @param block  the block.
    062         * @param key  the key (<code>null</code> permitted).
    063         */
    064        public void add(Block block, Object key);
    065
    066        /**
    067         * Arranges the blocks within the specified container, subject to the given
    068         * constraint.
    069         *
    070         * @param container  the container.
    071         * @param g2  the graphics device.
    072         * @param constraint  the constraint.
    073         *
    074         * @return The container size after the arrangement.
    075         */
    076        public Size2D arrange(BlockContainer container,
    077                              Graphics2D g2,
    078                              RectangleConstraint constraint);
    079
    080        /**
    081         * Clears any cached layout information retained by the arrangement.
    082         */
    083        public void clear();
    084
    085    }